Lattice Grid Buy a licence

demo D298

Manufacturing quality analysis in React

100,000 measurements from eight production lines: a process strip, a distribution, a control chart, two derived panels and the readings themselves, all recomputing from one line click

statistics.capability · mode: derived · createStat

A whole quality screen over 100,000 bore measurements from eight production lines: Cpk, mean, spread and the out-of-tolerance count, a distribution drawn against the tolerance, a control chart, a per-line summary, the readings that broke the limits, and the measurements themselves. Click Line 3 and every figure recomputes over that line alone, then click an exception and the grid scrolls to the record behind it.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid, createHeadlessGrid, createStat } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/charts.esm.min.js';

  const { LatticeGrid, LatticeChart } = createLatticeReact({ React, createGrid, createChart });

  const SPEC = { lower: 11.94, upper: 12.06, target: 12 };

  const columns = [
    { field: 'measurementId', title: 'Measurement' },
    { field: 'timestamp', title: 'Time', type: 'datetime' },
    { field: 'line', title: 'Line', filter: { type: 'set' } },
    { field: 'machine', title: 'Machine', filter: { type: 'set' } },
    { field: 'measurement', title: 'Bore', type: 'number',
      format: { decimals: 4, suffix: ' mm' }, spec: SPEC, total: 'median' },
    { field: 'deviation', title: 'Off target', type: 'number', format: { decimals: 4 } },
    { field: 'outOfSpec', title: 'Out of spec', type: 'number', layout: { hidden: true } },
  ];

  const rows = [/* readings: measurementId, timestamp, line, machine, measurement, deviation, outOfSpec */];

  const byLineColumns = [
    { field: 'line', title: 'Line' },
    { field: 'readings', title: 'Readings', type: 'number' },
    { field: 'mean', title: 'Mean', type: 'number', format: { decimals: 4 } },
    { field: 'sigma', title: 'Sigma', type: 'number', format: { decimals: 5 } },
    // Ppk is the panel's own mean and spread against the tolerance, which is
    // how the index is defined; it matches what statistics.capability() returns.
    { id: 'ppk', title: 'Ppk', type: 'number', format: { decimals: 2 },
      value: { deps: ['mean', 'sigma'], compute: (d) => d.sigma > 0
        ? Math.min((SPEC.upper - d.mean) / (3 * d.sigma), (d.mean - SPEC.lower) / (3 * d.sigma))
        : null } },
    { field: 'defects', title: 'Out of spec', type: 'number' },
  ];

  const exceptionColumns = [
    { field: 'timestamp', title: 'Time', type: 'datetime' },
    { field: 'machine', title: 'Machine' },
    { field: 'measurement', title: 'Bore', type: 'number', format: { decimals: 4, suffix: ' mm' } },
    { field: 'deviation', title: 'Off target', type: 'number', format: { decimals: 4 } },
  ];

  function App() {
    const tilesRef = React.useRef(null);
    const [measurements, setMeasurements] = React.useState(null);
    const [readingsGrid, setReadingsGrid] = React.useState(null);

    // The tiles, the control chart's sample and the row:clicked wiring all
    // read the live measurements grid, once it exists.
    React.useEffect(() => {
      if (!measurements || !tilesRef.current) return undefined;

      // One capability pass per state of the screen, shared by every tile:
      // keyed on what the grid is showing rather than invalidated by a
      // listener, so it does not matter which recomputes first.
      let token = '';
      let cap = null;
      const capability = () => {
        const now = measurements.rows.count() + '|' + JSON.stringify(measurements.filters.get() ?? null);
        if (now !== token) { token = now; cap = measurements.statistics.capability('measurement'); }
        return cap;
      };
      const tile = () => tilesRef.current.appendChild(document.createElement('div'));

      // Each tile is banded in its own direction. bands judges the value;
      // goodWhen judges the change. A Cpk of 0.9 is bad news whichever way it got there.
      const stats = [
        createStat({
          grid: measurements, container: tile(), title: 'Cpk',
          value: () => capability()?.cpk ?? null, decimals: 2,
          bands: { good: 1.33, warn: 1.0 }, goodWhen: 'up', baseline: 1.33,
          interval: () => capability()?.interval ?? null,
        }),
        createStat({
          grid: measurements, container: tile(), title: 'Mean bore',
          value: () => capability()?.mean ?? null, decimals: 4,
          goodWhen: 'neither', baseline: SPEC.target,
        }),
        createStat({
          grid: measurements, container: tile(), title: 'Sigma',
          value: () => capability()?.sigmaOverall ?? null, decimals: 5,
          bands: { good: 0.015, warn: 0.02, direction: 'down' }, goodWhen: 'down',
        }),
        createStat({
          grid: measurements, container: tile(), title: 'Out of tolerance',
          value: () => capability()?.outOfSpec ?? null, decimals: 0,
          // A count cannot be banded on its own number when the row set
          // changes size. Band it on the rate it represents and the tile
          // means one thing at every level.
          bands: (value) => {
            const total = measurements.rows.count();
            if (!total) return null;
            const rate = value / total;
            return rate <= 0.001 ? 'good' : rate <= 0.01 ? 'warn' : 'bad';
          },
          goodWhen: 'down',
        }),
      ];

      // An individuals control chart puts one reading on each point, so it is
      // bound to readings, not to a summary of them: take every stride-th
      // reading in production order rather than averaging them into buckets first.
      const sample = [];
      const stride = Math.max(1, Math.ceil(measurements.rows.count() / 240));
      for (let i = 0; i < measurements.rows.count(); i += stride) sample.push(measurements.rows.get(i).data);
      const readings = createHeadlessGrid({
        rowKey: 'id', rows: sample,
        columns: [{ field: 'measurement', type: 'number', spec: SPEC }],
      });
      setReadingsGrid(readings);

      return () => { for (const s of stats) s.destroy(); readings.destroy(); };
    }, [measurements]);

    const onExceptionsReady = (exceptions) => {
      // A derived row still carries the fields it was derived from, so the
      // key is enough to reach the reading in the grid underneath.
      exceptions.on('row:clicked', (e) => {
        const id = e.row.data.id;
        measurements.selection.set([id]);
        measurements.scroll.toRow(id);
        measurements.highlight({ key: id }, { colour: '#fdeaea', duration: 0 });
      });
    };

    return (
      <>
        <button onClick={() => measurements?.filters.set({ col: 'line', op: 'eq', value: 'Line 3' })} disabled={!measurements}>
          Filter to Line 3
        </button>
        <div ref={tilesRef} style={{ display: 'grid', gridTemplateColumns: 'repeat(4, 1fr)', gap: '12px', marginTop: '10px' }} />
        {/* The distribution reads the measurements directly and redraws as they narrow. */}
        {measurements && <LatticeChart grid={measurements} type="capability" y="measurement" style={{ height: '260px', marginTop: '14px' }} />}
        {readingsGrid && <LatticeChart grid={readingsGrid} type="control" y="measurement" rules="nelson" style={{ height: '260px', marginTop: '14px' }} />}
        {/* A derived grid: it reads whatever the measurements grid is
            filtered to, groups it and reduces it, so a filter above rewrites this panel. */}
        {measurements && (
          <LatticeGrid
            source={{ mode: 'derived', from: measurements, follow: 'filtered', refresh: 'live',
              groupBy: 'line',
              select: {
                readings: { fn: 'count' },
                mean: { of: 'measurement', fn: 'avg' },
                sigma: { of: 'measurement', fn: 'stddev' },
                defects: { of: 'outOfSpec', fn: 'sum' },
              } }}
            state={{ sort: [{ col: 'ppk', dir: 'asc' }] }}
            columns={byLineColumns}
            style={{ height: '300px', marginTop: '14px' }}
          />
        )}
        {/* A second derived grid: the same rows, narrowed rather than grouped. */}
        {measurements && (
          <LatticeGrid
            source={{ mode: 'derived', from: measurements, follow: 'filtered', refresh: 'live',
              where: (r) => r.outOfSpec === 1, sort: [{ col: 'ts', dir: 'desc' }] }}
            selection={{ mode: 'single' }}
            columns={exceptionColumns}
            onGridReady={onExceptionsReady}
            style={{ height: '300px', marginTop: '14px' }}
          />
        )}
        <LatticeGrid
          rowKey="id"
          selection={{ mode: 'single' }}
          columnDefaults={{ filter: true }}
          columns={columns}
          rows={rows}
          onGridReady={setMeasurements}
          style={{ height: '380px', marginTop: '14px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

From a number you distrust to the record that explains it

Eight lines have been running for a week, and the plant-wide figures at the top are the ones a report would carry: a capability index, the average bore, the spread of the readings and how many of them fell outside the tolerance the customer set. They say something is not right. They cannot say what.

Everything on this screen reads the measurements grid at the bottom, so narrowing it narrows all of them together. Pick a line from the chips and the four figures recompute, the distribution redraws, the control chart redraws, the per-line summary re-derives and the exception list re-derives, over the readings that are left. Nothing is refetched and there is no second copy of the data anywhere on the page.

The Process by line panel is the one that answers the question. It is sorted worst first, so the line that needs attention is the top row. Its mean sits high, its spread is wider than every other line’s, its Cpk is the only one under the floor, and its Ppk, the index that judges the whole run rather than the moment, is lower still. That gap between the two is the finding: a process that is repeatable minute to minute and has been allowed to wander over the week.

What the click actually does

Click Line 3 and the whole screen becomes that one line. The distribution slides toward the upper tolerance instead of sitting centred on target. The control chart, which is now a genuine single-process chart rather than eight processes overlaid, climbs steadily from the centre line towards the upper limit. The out-of-tolerance count that looked small across the plant is revealed as almost entirely one line’s, and at that line’s own volume it is a rate an inspector would stop the line over.

Then click a row in Exceptions. The measurements grid scrolls to that reading and marks it, and the panel underneath opens the operational record: the machine, the operator, the batch, the shift, the bore and how far off target it landed, the tolerance it was judged against, and the temperature, pressure and speed the machine was running at when it was taken. That is the whole round trip in three clicks. A figure you distrust, the cause behind it, and the record you can act on.

Where each figure comes from

The four figures at the top are one capability pass over the rows in view, so they cannot disagree with each other or with the charts. Cpk and the spread are read from that pass, not assembled by hand. The Cpk tile carries its confidence interval underneath, because a capability index quoted without one is the commonest way a capability study overstates itself.

Each tile is banded in its own direction, which is not a detail. Higher Cpk is better, so its bands run upward from the 1.33 floor. Lower spread is better, so its bands run the other way, with cut points taken from the tolerance itself: a centred process holds Cpk 1.33 up to 0.015 mm of spread and Cpk 1.0 up to 0.020. Fewer out-of-tolerance readings is better, and because the count is graded on the rate it represents rather than on the raw number, the tile means the same thing whether eight lines are in view or one. The mean carries no band at all, because a mean is not better high or low, it is better close to target, and colouring it either way would be a claim the number does not support.

The Process by line panel is a derived grid: it groups whatever the measurements grid is filtered to and reduces it, so a filter above rewrites the panel with no second query. Its Ppk column is computed from the panel’s own mean and spread, which is exactly how the index is defined, and it matches the number the statistics engine returns for the same rows.

Why the control chart plots readings rather than averages

An individuals chart puts one reading on each point and estimates short-term variation from the gaps between consecutive readings. Rolling the readings into hourly averages first and charting those would look tidier and would be a different instrument with different limits, so the chart takes a sample of the readings themselves, every stride-th one in production order, and says in its title exactly which ones it drew.

How do I build a screen where filtering one grid recomputes everything?

Put the readings in a grid, declare the tolerance on the column with spec: { lower, upper, target }, and let every panel above read that grid. createStat tiles bound to it recompute on every filter change. A source: { mode: 'derived', from: measurements, follow: 'filtered', groupBy: 'line', select: { … } } grid re-derives from whatever is left. grid.statistics.capability('measurement') returns Cp, Cpk, Pp, Ppk, both estimates of sigma, the out-of-tolerance count and the rule violations over the rows in view. Because the tolerance is declared once on the column, the tiles, the distribution and the control chart cannot disagree about what the limits are.

Lattice Grid Buy a licence

demo D298

Manufacturing quality analysis in Angular

100,000 measurements from eight production lines: a process strip, a distribution, a control chart, two derived panels and the readings themselves, all recomputing from one line click

statistics.capability · mode: derived · createStat

A whole quality screen over 100,000 bore measurements from eight production lines: Cpk, mean, spread and the out-of-tolerance count, a distribution drawn against the tolerance, a control chart, a per-line summary, the readings that broke the limits, and the measurements themselves. Click Line 3 and every figure recomputes over that line alone, then click an exception and the grid scrolls to the record behind it.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, signal } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, createHeadlessGrid, createStat, type Grid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import { LatticeGridComponent, LatticeChartComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

const SPEC = { lower: 11.94, upper: 12.06, target: 12 };

const columns = [
  { field: 'measurementId', title: 'Measurement' },
  { field: 'timestamp', title: 'Time', type: 'datetime' },
  { field: 'line', title: 'Line', filter: { type: 'set' } },
  { field: 'machine', title: 'Machine', filter: { type: 'set' } },
  { field: 'measurement', title: 'Bore', type: 'number',
    format: { decimals: 4, suffix: ' mm' }, spec: SPEC, total: 'median' },
  { field: 'deviation', title: 'Off target', type: 'number', format: { decimals: 4 } },
  { field: 'outOfSpec', title: 'Out of spec', type: 'number', layout: { hidden: true } },
];
const rows = [/* readings: measurementId, timestamp, line, machine, measurement, deviation, outOfSpec */];

const byLineColumns = [
  { field: 'line', title: 'Line' },
  { field: 'readings', title: 'Readings', type: 'number' },
  { field: 'mean', title: 'Mean', type: 'number', format: { decimals: 4 } },
  { field: 'sigma', title: 'Sigma', type: 'number', format: { decimals: 5 } },
  // Ppk is the panel's own mean and spread against the tolerance, which is
  // how the index is defined; it matches what statistics.capability() returns.
  { id: 'ppk', title: 'Ppk', type: 'number', format: { decimals: 2 },
    value: { deps: ['mean', 'sigma'], compute: (d: any) => d.sigma > 0
      ? Math.min((SPEC.upper - d.mean) / (3 * d.sigma), (d.mean - SPEC.lower) / (3 * d.sigma))
      : null } },
  { field: 'defects', title: 'Out of spec', type: 'number' },
];

const exceptionColumns = [
  { field: 'timestamp', title: 'Time', type: 'datetime' },
  { field: 'machine', title: 'Machine' },
  { field: 'measurement', title: 'Bore', type: 'number', format: { decimals: 4, suffix: ' mm' } },
  { field: 'deviation', title: 'Off target', type: 'number', format: { decimals: 4 } },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent, LatticeChartComponent],
  template:
    '<button (click)="filterLine3()" [disabled]="!measurements">Filter to Line 3</button>' +
    '<div #tiles style="display:grid;grid-template-columns:repeat(4,1fr);gap:12px;margin-top:10px"></div>' +
    '@if (measurements) {' +
    '  <lattice-chart [grid]="measurements" [config]="distributionConfig" style="display:block;height:260px;margin-top:14px"></lattice-chart>' +
    '}' +
    '@if (readingsGrid(); as rg) {' +
    '  <lattice-chart [grid]="rg" [config]="controlConfig" style="display:block;height:260px;margin-top:14px"></lattice-chart>' +
    '}' +
    '@if (byLineConfig(); as bc) {' +
    '  <lattice-grid [config]="bc" style="display:block;height:300px;margin-top:14px"></lattice-grid>' +
    '}' +
    '@if (exceptionsConfig(); as ec) {' +
    '  <lattice-grid [config]="ec" (gridReady)="onExceptionsReady($event)" style="display:block;height:300px;margin-top:14px"></lattice-grid>' +
    '}' +
    '<lattice-grid [config]="measurementsConfig" (gridReady)="onMeasurementsReady($event)" style="display:block;height:380px;margin-top:14px"></lattice-grid>',
})
export class AppComponent {
  @ViewChild('tiles') tilesRef: any;

  measurements: Grid | null = null;
  readingsGrid = signal<Grid | null>(null);
  byLineConfig = signal<any>(null);
  exceptionsConfig = signal<any>(null);

  distributionConfig = { type: 'capability', y: 'measurement' };
  controlConfig = { type: 'control', y: 'measurement', rules: 'nelson' };

  measurementsConfig = {
    rowKey: 'id',
    selection: { mode: 'single' },
    columnDefaults: { filter: true },
    columns,
    rows,
  };

  onMeasurementsReady(grid: Grid) {
    this.measurements = grid;

    // One capability pass per state of the screen, shared by every tile:
    // keyed on what the grid is showing rather than invalidated by a
    // listener, so it does not matter which recomputes first.
    let token = '';
    let cap: any = null;
    const capability = () => {
      const now = grid.rows.count() + '|' + JSON.stringify(grid.filters.get() ?? null);
      if (now !== token) { token = now; cap = (grid as any).statistics.capability('measurement'); }
      return cap;
    };
    const tile = () => this.tilesRef.nativeElement.appendChild(document.createElement('div'));

    // Each tile is banded in its own direction. bands judges the value;
    // goodWhen judges the change. A Cpk of 0.9 is bad news whichever way it got there.
    createStat({ grid, container: tile(), title: 'Cpk',
      value: () => capability()?.cpk ?? null, decimals: 2,
      bands: { good: 1.33, warn: 1.0 }, goodWhen: 'up', baseline: 1.33,
      interval: () => capability()?.interval ?? null });
    createStat({ grid, container: tile(), title: 'Mean bore',
      value: () => capability()?.mean ?? null, decimals: 4,
      goodWhen: 'neither', baseline: SPEC.target });
    createStat({ grid, container: tile(), title: 'Sigma',
      value: () => capability()?.sigmaOverall ?? null, decimals: 5,
      bands: { good: 0.015, warn: 0.02, direction: 'down' }, goodWhen: 'down' });
    createStat({ grid, container: tile(), title: 'Out of tolerance',
      value: () => capability()?.outOfSpec ?? null, decimals: 0,
      // A count cannot be banded on its own number when the row set changes
      // size. Band it on the rate it represents and the tile means one thing
      // at every level.
      bands: (value: number) => {
        const total = grid.rows.count();
        if (!total) return null;
        const rate = value / total;
        return rate <= 0.001 ? 'good' : rate <= 0.01 ? 'warn' : 'bad';
      }, goodWhen: 'down' });

    // An individuals control chart puts one reading on each point, so it is
    // bound to readings, not to a summary of them: take every stride-th
    // reading in production order rather than averaging them into buckets first.
    const sample: any[] = [];
    const stride = Math.max(1, Math.ceil(grid.rows.count() / 240));
    for (let i = 0; i < grid.rows.count(); i += stride) sample.push(grid.rows.get(i).data);
    this.readingsGrid.set(createHeadlessGrid({
      rowKey: 'id', rows: sample,
      columns: [{ field: 'measurement', type: 'number', spec: SPEC }],
    }));

    // A derived grid: it reads whatever the measurements grid is filtered
    // to, groups it and reduces it, so a filter above rewrites this panel.
    this.byLineConfig.set({
      source: { mode: 'derived', from: grid, follow: 'filtered', refresh: 'live',
        groupBy: 'line',
        select: {
          readings: { fn: 'count' },
          mean: { of: 'measurement', fn: 'avg' },
          sigma: { of: 'measurement', fn: 'stddev' },
          defects: { of: 'outOfSpec', fn: 'sum' },
        } },
      state: { sort: [{ col: 'ppk', dir: 'asc' }] },
      columns: byLineColumns,
    });

    // A second derived grid: the same rows, narrowed rather than grouped.
    this.exceptionsConfig.set({
      source: { mode: 'derived', from: grid, follow: 'filtered', refresh: 'live',
        where: (r: any) => r.outOfSpec === 1, sort: [{ col: 'ts', dir: 'desc' }] },
      selection: { mode: 'single' },
      columns: exceptionColumns,
    });
  }

  onExceptionsReady(exceptions: Grid) {
    // A derived row still carries the fields it was derived from, so the key
    // is enough to reach the reading in the grid underneath.
    exceptions.on('row:clicked', (e: any) => {
      const id = e.row.data.id;
      this.measurements!.selection.set([id]);
      this.measurements!.scroll.toRow(id);
      this.measurements!.highlight({ key: id }, { colour: '#fdeaea', duration: 0 });
    });
  }

  filterLine3() {
    this.measurements?.filters.set({ col: 'line', op: 'eq', value: 'Line 3' });
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid, createChart })],
});

From a number you distrust to the record that explains it

Eight lines have been running for a week, and the plant-wide figures at the top are the ones a report would carry: a capability index, the average bore, the spread of the readings and how many of them fell outside the tolerance the customer set. They say something is not right. They cannot say what.

Everything on this screen reads the measurements grid at the bottom, so narrowing it narrows all of them together. Pick a line from the chips and the four figures recompute, the distribution redraws, the control chart redraws, the per-line summary re-derives and the exception list re-derives, over the readings that are left. Nothing is refetched and there is no second copy of the data anywhere on the page.

The Process by line panel is the one that answers the question. It is sorted worst first, so the line that needs attention is the top row. Its mean sits high, its spread is wider than every other line’s, its Cpk is the only one under the floor, and its Ppk, the index that judges the whole run rather than the moment, is lower still. That gap between the two is the finding: a process that is repeatable minute to minute and has been allowed to wander over the week.

What the click actually does

Click Line 3 and the whole screen becomes that one line. The distribution slides toward the upper tolerance instead of sitting centred on target. The control chart, which is now a genuine single-process chart rather than eight processes overlaid, climbs steadily from the centre line towards the upper limit. The out-of-tolerance count that looked small across the plant is revealed as almost entirely one line’s, and at that line’s own volume it is a rate an inspector would stop the line over.

Then click a row in Exceptions. The measurements grid scrolls to that reading and marks it, and the panel underneath opens the operational record: the machine, the operator, the batch, the shift, the bore and how far off target it landed, the tolerance it was judged against, and the temperature, pressure and speed the machine was running at when it was taken. That is the whole round trip in three clicks. A figure you distrust, the cause behind it, and the record you can act on.

Where each figure comes from

The four figures at the top are one capability pass over the rows in view, so they cannot disagree with each other or with the charts. Cpk and the spread are read from that pass, not assembled by hand. The Cpk tile carries its confidence interval underneath, because a capability index quoted without one is the commonest way a capability study overstates itself.

Each tile is banded in its own direction, which is not a detail. Higher Cpk is better, so its bands run upward from the 1.33 floor. Lower spread is better, so its bands run the other way, with cut points taken from the tolerance itself: a centred process holds Cpk 1.33 up to 0.015 mm of spread and Cpk 1.0 up to 0.020. Fewer out-of-tolerance readings is better, and because the count is graded on the rate it represents rather than on the raw number, the tile means the same thing whether eight lines are in view or one. The mean carries no band at all, because a mean is not better high or low, it is better close to target, and colouring it either way would be a claim the number does not support.

The Process by line panel is a derived grid: it groups whatever the measurements grid is filtered to and reduces it, so a filter above rewrites the panel with no second query. Its Ppk column is computed from the panel’s own mean and spread, which is exactly how the index is defined, and it matches the number the statistics engine returns for the same rows.

Why the control chart plots readings rather than averages

An individuals chart puts one reading on each point and estimates short-term variation from the gaps between consecutive readings. Rolling the readings into hourly averages first and charting those would look tidier and would be a different instrument with different limits, so the chart takes a sample of the readings themselves, every stride-th one in production order, and says in its title exactly which ones it drew.

How do I build a screen where filtering one grid recomputes everything?

Put the readings in a grid, declare the tolerance on the column with spec: { lower, upper, target }, and let every panel above read that grid. createStat tiles bound to it recompute on every filter change. A source: { mode: 'derived', from: measurements, follow: 'filtered', groupBy: 'line', select: { … } } grid re-derives from whatever is left. grid.statistics.capability('measurement') returns Cp, Cpk, Pp, Ppk, both estimates of sigma, the out-of-tolerance count and the rule violations over the rows in view. Because the tolerance is declared once on the column, the tiles, the distribution and the control chart cannot disagree about what the limits are.